<?php
/*======================================================================*\
|| #################################################################### ||
|| # Youjoomla YJ Moz News Slider 
|| # Youjoomla.com - YJ- Licence Number 98197-KF513918
|| # Licensed to - Hejakal Bekaudar
|| # ---------------------------------------------------------------- # ||
|| # Copyright (C) 2006-2009 Youjoomla.com. All Rights Reserved.        ||
|| # This file may not be redistributed in whole or significant part. # ||
|| # ---------------- THIS IS NOT FREE SOFTWARE ---------------- #      ||
|| # http://www.youjoomla.com | http://www.youjoomla.com/license.html # ||
|| #################################################################### ||
\*======================================================================*/

// no direct access
defined('_JEXEC') or die('Restricted access');

JHtml::_('behavior.framework',true);
require_once (JPATH_SITE.DIRECTORY_SEPARATOR.'components'.DIRECTORY_SEPARATOR.'com_content'.DIRECTORY_SEPARATOR.'helpers'.DIRECTORY_SEPARATOR.'route.php');
require_once('modules/mod_yj_moz_slider/lib/slike.php');

class modYJmozSliderhHelper
{
	function getYJmozSliderItems(&$params)
	{
		
		$get_items             	= $params->get   ('get_items',1);
		$nitems                	= $params->get   ('nitems',4);
		$chars                 	= $params->get   ('chars',40);
		$chars_nav             	= $params->get   ('chars_nav',40);
		$ordering              	= $params->get   ('ordering',3);// 1 = ordering | 2 = popular | 3 = random 
		$getspecific 	         	= $params->get ('getspecific');
		$allow_tags				= $params->get ('allow_tags');
		$allow_tags 				= str_replace(" />", ">", $allow_tags);
		
		$slider_width 	  		= $params->get ('slider_width',960);
		$slider_height      	= $params->get ('slider_height',300);
		$intro_width 	 	  	= $params->get ('intro_width',550);
		$intro_height       	= $params->get ('intro_height',160);
		
		$autoSlide         		= $params->get ('autoSlide',5000);
	
		$document = &JFactory::getDocument();
		$document->addStyleSheet(JURI::base() . 'modules/mod_yj_moz_slider/css/stylesheet.css');
		$document->addScript(JURI::base() . 'modules/mod_yj_moz_slider/script/yj_moz_slider12.js');
		$document->addScriptDeclaration("
			window.addEvent('load', function(){
					new YJ_Moz_Slider({
						container: 'MozaicSlider', // overall container, element containing all slides
						slides: '.slide', // single slide container css class
						images:'.image', // inside single slide, css class for image container
						infos: '.info', // inside single slide, css class for info container
						infosFx:{
							duration: 500, // info container fx duration
							fx: Fx.Transitions.Sine.easeOut // info container fx
						},
						infosFxCss:{ // here you can change the info containers fx. You need to set all 3 instances: show, hide and hidden to make sure this works
							showFx:{ // set this to how you want the info container to appear
								'bottom':0,
								'opacity':1
							},
							hideFx:{ // set this to how you want it to dissapear
								'bottom':-".$intro_height .",
								'opacity':0
							},
							hiddenFx:{ // if not the current slide, infos need to be hidden. Set the hidden instance here
								'bottom':-".$intro_height .",
								'opacity':0
							}
						}, // remember, for all 3 you need to play with the same properties
						gridW:10, // grid pieces width
						gridH:5, // grid pieces height
						navigators: '#MozaicNavigation li a', // complete path to navigation, can be anything as long as the number of elements is equal to the number of slides
						currentNavClass: 'selected', // css class to highlight navigator currently running
						autoSlide:".$autoSlide." // set to 0/null/false to stop autoslide				
					});			
			});
		");

				/* prepare database */
		$db			=& JFactory::getDBO();
		$user		=& JFactory::getUser();
		$userId		= (int) $user->get('id');
		$aid		= JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
		$contentConfig = &JComponentHelper::getParams( 'com_content' );
		$access		= !JComponentHelper::getParams('com_content')->get('show_noauth');
		$nullDate	= $db->getNullDate();
		$date =       & JFactory::getDate();
		if(intval(JVERSION) >= 3 ){	
			$now =         $date->toSql() ; 
		}else{
			$now =         $date->toMySQL(); 
		}
		
		$where		= 'a.state = 1'
			. ' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )'
			. ' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )'
			;
		// select specific items
		if(!empty($getspecific)){
		$countitems = count($getspecific);
		}
		if(!empty($getspecific) && $countitems > 1 ){
			$specificitems = implode(",", $getspecific);
			$specific_order= 'field(a.id,'.$specificitems.')';
			$where .= ' AND a.id IN ('.$specificitems.')';
		}elseif(!empty($getspecific) && $countitems == 1 ){
			$specificitems = $getspecific[0];
			$specific_order= 'field(a.id,'.$specificitems.')';
			$where .= ' AND a.id IN ('.$specificitems.')';
		}else{
			$specificitems='';
			$specific_order='NULL';
			$where .= ' AND cc.id = '.$get_items.'';
		}
		/* set items order */
		$ord = array(
			1=>'ordering',
			2=>'hits',
			3=>'RAND()',
			4=>'created ASC',
			5=>'created DESC',
			6=>$specific_order
		);
		$order = $ord[$ordering];
		/* get items */
		$sql = 	'SELECT a.*, ' .
				' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'. 
				' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug,'.
				'cc.title as cattitle'.
		
				' FROM #__content AS a' .
				' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
				' WHERE '. $where .'' .
				($access ? ' AND a.access <= ' .(int) $aid. ' AND cc.access <= ' .(int) $aid : '').
				' AND cc.published = 1' .
				' ORDER BY '.$order .' LIMIT 0,'.$nitems.'';
					
		$db->setQuery( $sql );
		$load_items = $db->loadObjectList();
		
		
		$mozaic_slides = array();
			foreach ( $load_items as $row ) {
				$mosaic_slide = array(
						'date' => JHTML::_('date', $row->created, '%d-%m-%Y'),
						'intro' 	=> substr(strip_tags($row->introtext,''. $allow_tags.''),0,$chars),
						'link' 		=> htmlspecialchars(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug), ENT_QUOTES, 'UTF-8'),
						'img_url' => $img_url = mozaic_image($row),
						'title' 	=> htmlspecialchars($row->title, ENT_QUOTES, 'UTF-8'),
						'img_url' => '',
						'img_out' =>"<img src=\"".JURI::base().$img_url."\" title=\"".$row->title." \"  alt=\"\"/>"
					);
					$mozaic_slides[] = $mosaic_slide;
					
				} 
		
				return $mozaic_slides;
	}
}
?>